using FluentValidation;
using CMSMicroservice.Protobuf.Protos.ProductImages;
namespace CMSMicroservice.Protobuf.Validator.ProductImages;

public class GetProductImagesRequestValidator : AbstractValidator<GetProductImagesRequest>
{
    public GetProductImagesRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetProductImagesRequest>.CreateWithOptions((GetProductImagesRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
